Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1423378 - Build against python3 for Fedora releases
Summary: Build against python3 for Fedora releases
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: certbot
Version: 26
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: James Hogarth
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-02-17 07:54 UTC by Peter Robinson
Modified: 2017-09-11 14:39 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-09-11 14:39:50 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github certbot certbot issues 3179 0 None None None 2017-03-07 00:35:50 UTC

Description Peter Robinson 2017-02-17 07:54:36 UTC
So all recent releases of Fedora have been moving towards python3 as the default and in a lot of use cases now python2 isn't required. Recent releases of certbot now support python3 so it would be nice to build the core bindings/binaries as python3 based on Fedora so python2 doesn't need to get pulled in to use certbot.

Comment 1 James Hogarth 2017-02-17 07:58:03 UTC
Now that it supports it our guidelines make it imperative that python3 is preferred as well.

I'll look into this during the weekend, and the next Fedora release will be py3 based.

On the EPEL7 side I think there's a couple of packages that aren't packaged for python3 which might need changing possibly, so that will have to stay py2 for now.

Comment 2 Peter Robinson 2017-02-17 11:17:54 UTC
I think for EPEL it should remain as python2 as it's the distro base version so we're not pulling in the entire stack.

Comment 3 James Hogarth 2017-02-17 11:35:11 UTC
That's what I'm building and testing towards.

Just put together a spec that works nicely and cleanly upgrades from certbot py2 to certbot py3

I'll be pushing it to git in a short while and will have a build in koji not long after that.

I'll do the bodhi update after the present one has gone stable in F25 (just waiting on the next push now).

Comment 4 Fedora End Of Life 2017-02-28 11:28:08 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 26 development cycle.
Changing version to '26'.

Comment 5 Fedora Update System 2017-03-01 01:45:57 UTC
certbot-0.11.1-4.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-41ca72da29

Comment 6 Fedora Update System 2017-03-01 01:46:06 UTC
certbot-0.11.1-4.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-c5943ff10a

Comment 7 Fedora Update System 2017-03-02 02:21:28 UTC
certbot-0.11.1-4.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-c5943ff10a

Comment 8 Fedora Update System 2017-03-02 02:52:05 UTC
certbot-0.11.1-4.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-41ca72da29

Comment 9 Fedora Update System 2017-03-03 15:50:01 UTC
python-acme-0.12.0-2.fc25 python-certbot-apache-0.12.0-1.fc25 certbot-0.12.0-1.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-bad59d8d68

Comment 10 Fedora Update System 2017-03-03 15:50:22 UTC
python-acme-0.12.0-2.fc24 python-certbot-apache-0.12.0-1.fc24 certbot-0.12.0-1.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-ccc3e000c5

Comment 11 Brad Warren 2017-03-03 16:32:00 UTC
I'm a Certbot dev and while I'm happy to say progress has been made in making Certbot and python-certbot-apache Python 3 compatible, we're not quite there yet. Our unit tests pass on Python 3, but our integration tests with Let's Encrypt fail and people who try to use Certbot using Python 3 often report problems. For the time being, we're still telling people that Certbot isn't Python 3 compatible.

Released versions of Fedora should definitely continue to run Certbot on Python 2 for now. I would also recommend switching the Fedora 26/rawhide packages back to Python 2 as Certbot is known to not work with Python 3.

Comment 12 James Hogarth 2017-03-03 16:34:35 UTC
Ah thanks Brad.

I going by what Peter had above, with some basic testing.

No py3 based package has hit a stable repo yet so I'll flip it back over tonight.

Looking forward to the day you poke me that we can flip it to py3 properly :)

Comment 13 James Hogarth 2017-03-03 16:36:04 UTC
Oh to save me looking, do you happen to have a tracker bug in github I can link here as the upstream dependency?

Comment 14 Peter Robinson 2017-03-03 17:47:02 UTC
> Released versions of Fedora should definitely continue to run Certbot on
> Python 2 for now. I would also recommend switching the Fedora 26/rawhide
> packages back to Python 2 as Certbot is known to not work with Python 3.

This is quite ridiculous for a project that has been around for a little over a year not being py3 compatible from the outset. Basically for small images that would other wise not need python2 we now need to pull in an entire other software stack.

I would like to see it left enabled for F-26+ and the lets encrypt people work with us to smooth this out.

Comment 15 Fedora Update System 2017-03-03 22:50:32 UTC
certbot-0.12.0-1.fc25, python-acme-0.12.0-2.fc25, python-certbot-apache-0.12.0-1.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-bad59d8d68

Comment 16 Fedora Update System 2017-03-04 00:50:28 UTC
certbot-0.12.0-1.fc24, python-acme-0.12.0-2.fc24, python-certbot-apache-0.12.0-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-ccc3e000c5

Comment 17 James Hogarth 2017-03-04 07:56:43 UTC
Okay after sleeping on it here's what I'm going to do.

The packages will ship jws-2, jws-3, certbot-2 and certbot-3 with symlinks pointing jws and certbot to their -2 varieties for now.

This will default them all to py2 as per upstream's request but will allow easy testing of py3 behaviour on Fedora.

This will be packaged in this way in the next 24 hours.

Comment 18 Fedora Update System 2017-03-06 11:24:33 UTC
certbot-0.12.0-1.fc24 python-acme-0.12.0-2.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-ccc3e000c5

Comment 19 Fedora Update System 2017-03-06 11:26:50 UTC
certbot-0.12.0-2.fc24 python-acme-0.12.0-3.fc24 python-certbot-apache-0.12.0-1.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-0b35be64b3

Comment 20 Fedora Update System 2017-03-06 11:27:51 UTC
certbot-0.12.0-1.fc25 python-acme-0.12.0-2.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-bad59d8d68

Comment 21 Fedora Update System 2017-03-06 11:31:18 UTC
certbot-0.12.0-2.fc25 python-acme-0.12.0-3.fc25 python-certbot-apache-0.12.0-1.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-e06b5ed81c

Comment 22 Fedora Update System 2017-03-06 11:31:39 UTC
certbot-0.12.0-2.fc25 python-acme-0.12.0-3.fc25 python-certbot-apache-0.12.0-1.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-e06b5ed81c

Comment 23 Brad Warren 2017-03-06 22:30:04 UTC
> Oh to save me looking, do you happen to have a tracker bug in github I can link here as the upstream dependency?

I'm sorry I didn't see this sooner. Our GH issue tracking Python 3 support is https://github.com/certbot/certbot/issues/3179.

Comment 24 James Hogarth 2017-03-07 00:34:15 UTC
No problem, that's linked up now :)

Comment 25 Fedora Update System 2017-03-07 01:50:04 UTC
certbot-0.12.0-3.fc25, python-acme-0.12.0-3.fc25, python-certbot-apache-0.12.0-1.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-e06b5ed81c

Comment 26 Fedora Update System 2017-03-07 10:00:13 UTC
certbot-0.12.0-4.fc25 python-acme-0.12.0-3.fc25 python-certbot-apache-0.12.0-1.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-e06b5ed81c

Comment 27 Fedora Update System 2017-03-07 16:51:35 UTC
certbot-0.12.0-4.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-c51c77f333

Comment 28 Fedora Update System 2017-03-07 17:52:48 UTC
certbot-0.12.0-3.fc24, python-acme-0.12.0-3.fc24, python-certbot-apache-0.12.0-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-0b35be64b3

Comment 29 Fedora Update System 2017-03-07 19:11:13 UTC
certbot-0.12.0-4.fc24 python-acme-0.12.0-3.fc24 python-certbot-apache-0.12.0-1.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-0b35be64b3

Comment 30 Fedora Update System 2017-03-08 14:52:39 UTC
certbot-0.12.0-4.fc24, python-acme-0.12.0-3.fc24, python-certbot-apache-0.12.0-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-0b35be64b3

Comment 31 Fedora Update System 2017-03-08 14:53:43 UTC
certbot-0.12.0-4.fc25, python-acme-0.12.0-3.fc25, python-certbot-apache-0.12.0-1.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-e06b5ed81c

Comment 32 Fedora Update System 2017-03-10 23:20:02 UTC
certbot-0.12.0-4.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-c51c77f333

Comment 33 Fedora Update System 2017-03-16 21:17:45 UTC
certbot-0.12.0-4.fc24, python-acme-0.12.0-3.fc24, python-certbot-apache-0.12.0-1.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 34 Fedora Update System 2017-03-16 22:20:46 UTC
certbot-0.12.0-4.fc25, python-acme-0.12.0-3.fc25, python-certbot-apache-0.12.0-1.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 35 Fedora Update System 2017-04-01 16:50:52 UTC
certbot-0.12.0-4.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.

Comment 36 Peter Robinson 2017-05-09 22:57:28 UTC
So with the latest upstream update that py3 is supported as of 0.14.0 release I think it should be at least enabled in rawhide/f27 to get wider testing so we can report back any issues, then back ported to F-26 then stable Fedora releases based on that feedback

https://github.com/certbot/certbot/issues/3179#issuecomment-299923523

Comment 37 James Hogarth 2017-05-12 17:10:50 UTC
Having chatted with pdee today on IRC I agree

I'm initially going to do the builds as usual so that all the builds on py2 are done and in koji and easy to switch to if need be

Then in a few days I'll do a new build for rawhide and F26 flipping to py3 ahead of the F26 beta for a solid round of testing in that

After a few weeks of F26 then I'll issue an update for F25 as well.

Comment 38 Peter Robinson 2017-05-14 16:06:46 UTC
> Then in a few days I'll do a new build for rawhide and F26 flipping to py3
> ahead of the F26 beta for a solid round of testing in that

Just to note that F-26 freezes for Beta on Tues 16th May so it's likely it'll hang around in updates-testing until Beta gets signed off.

Comment 39 Fedora Update System 2017-05-19 16:59:57 UTC
certbot-0.14.1-3.fc26 python-acme-0.14.1-1.fc26 python-certbot-apache-0.14.1-1.fc26 python-certbot-nginx-0.14.1-1.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-64270716a0

Comment 40 Fedora Update System 2017-05-19 17:00:39 UTC
certbot-0.14.1-3.fc26 python-acme-0.14.1-1.fc26 python-certbot-apache-0.14.1-1.fc26 python-certbot-nginx-0.14.1-1.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-64270716a0

Comment 41 Fedora Update System 2017-05-20 08:16:48 UTC
certbot-0.14.1-3.fc26, python-acme-0.14.1-1.fc26, python-certbot-apache-0.14.1-1.fc26, python-certbot-nginx-0.14.1-1.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-64270716a0

Comment 42 Fedora Update System 2017-06-09 18:52:03 UTC
certbot-0.14.1-3.fc26, python-acme-0.14.1-1.fc26, python-certbot-apache-0.14.1-1.fc26, python-certbot-nginx-0.14.1-1.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.